<template>
    <el-dialog :title="title" v-model="visible" width="80%"
               :close-on-click-modal="false" draggable>
        <el-form ref="dataFormRef" :model="form" :rules="dataRules" label-width="130px" v-loading="loading" :disabled="operType === 'view'">
            <el-row :gutter="24">
                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.formName')" prop="formName">
                        <el-input v-model="form.formName" :placeholder="t('tabsOption.inputFormNameTip')" maxlength="20" show-word-limit clearable/>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.icon')" prop="icon">
                        <IconSelector :placeholder="$t('tabsOption.inputIconTip')" v-model="form.icon" />
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.groupName')" prop="groupName">
                        <el-select v-model="form.groupName" :placeholder="t('tabsOption.inputGroupNameTip')" style="width: 80%!important;"
                                   clearable filterable allowCreate defaultFirstOption>
                            <el-option v-for="(item, index) in dicData.groupName" :key="index" :label="item.groupName" :value="item.groupName"></el-option>
                        </el-select>

                        <el-button
                                type="primary" size="small" round style="margin-left: 10px"
                                @click="handleAddGroupName"
                        >新增分组
                        </el-button>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.type')" prop="type">
                        <el-select v-model="form.type" :placeholder="t('tabsOption.inputTypeTip')" clearable filterable>
                            <el-option v-for="(item, index) in DIC_PROP.FORM_TYPE" :key="index" :label="item.label" :value="item.value"></el-option>
                        </el-select>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20" v-if="form.type === DIC_PROP.FORM_TYPE[1].value">
                    <el-form-item :label="t('tabsOption.path')" prop="path">
                        <el-tooltip content="当表单类型为系统表单时，可输入本地Vue组件路径，或者外部系统http或https开头的页面路径" placement="top">
                            <el-input v-model="form.path" :placeholder="t('tabsOption.inputPathTip')" clearable>
                            </el-input>
                        </el-tooltip>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('flowApplication.remark')" prop="remark">
                        <el-input v-model="form.remark" type="textarea" :placeholder="t('flowApplication.inputRemarkTip')"/>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.sort')" prop="sort">
                        <el-input-number :min="1" :max="1000" v-model="form.sort" :placeholder="t('tabsOption.inputSortTip')"></el-input-number>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.version')" prop="version">
                        <el-input-number :min="1" :max="1000" v-model="form.version" :placeholder="t('tabsOption.inputVersionTip')"></el-input-number>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.isActive')" prop="isActive">
                        <el-radio-group v-model="form.isActive">
                            <el-radio v-for="(item, index) in DIC_PROP.YES_OR_NO" :key="index" :label="item.value" >
                                {{ getLabelByLanguage(item) }}
                            </el-radio>
                        </el-radio-group>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.isAutoAudit')" prop="isAutoAudit">
                        <el-radio-group v-model="form.isAutoAudit">
                            <el-radio v-for="(item, index) in DIC_PROP.YES_OR_NO" :key="index" :label="item.value" >
                                {{ getLabelByLanguage(item) }}
                            </el-radio>
                        </el-radio-group>
                    </el-form-item>
                </el-col>

                <el-col :span="12" class="mb20">
                    <el-form-item :label="t('tabsOption.status')" prop="status">
                        <el-radio-group v-model="form.status">
                            <el-radio v-for="(item, index) in DIC_PROP.TEMP_STATUS" :key="index" :label="item.value" >
                                {{ getLabelByLanguage(item) }}
                            </el-radio>
                        </el-radio-group>
                    </el-form-item>
                </el-col>

            </el-row>
        </el-form>
        <template #footer v-if="operType !== 'view'">
        <span class="dialog-footer">
          <el-button @click="visible = false">{{ $t('common.cancelButtonText') }}</el-button>
          <el-button type="primary" @click="onSubmit" :disabled="loading">{{ $t('common.confirmButtonText') }}</el-button>
        </span>
        </template>
    </el-dialog>
</template>

<script setup lang="ts" name="TabsOptionDialog">

    import {useMessage, useMessageBox} from "/@/hooks/message";
    import { getObj, addObj, putObj } from '/@/api/order/flow-application'
    import { useI18n } from "vue-i18n"
    import {onLoadDicUrl, onUpdateDicData} from "/@/flow/components/convert-name/convert";
    import {DIC_PROP} from "../../support/dict-prop";
    import {notifyLeft} from "../../index";
    import {validateFormTypeSave} from "/@/api/order/order-key-vue";
    const emit = defineEmits(['refresh']);
    // 引入组件
    const IconSelector = defineAsyncComponent(() => import('/@/components/IconSelector/index.vue'));
    const { t } = useI18n();

    // 定义变量内容
    const dataFormRef = ref();
    const visible = ref(false);
    const loading = ref(false);
    const operType = ref(false);
    const title = ref('');
    // 定义字典
    const dicData = reactive({});
    const onLoad = onLoadDicUrl({key: "groupName"});
    const onUpdate = onUpdateDicData({key: "groupName"});
    onMounted(() => {
        onLoad(dicData);
    });

    // 提交表单数据
    const form = reactive({
        icon: '',
        formName: '',
        groupName: '',
        path: '',
        prop: '',
        isActive: '1',
        isAutoAudit: '0',
        status: '-1',
        version: 1,
        sort: 1,
    });

    // 定义校验规则
    const dataRules = ref({
        icon: [{required: true, message: '图标不能为空', trigger: 'blur'}],
        formName: [{required: true, message: '表单名称不能为空', trigger: 'blur'}],
        groupName: [{required: true, message: '分组名称不能为空', trigger: 'blur'}],
        prop: [{required: true, message: 'tab标识不能为空', trigger: 'blur'}],
        isActive: [{required: true, message: '默认展示不能为空', trigger: 'blur'}],
        isAutoAudit: [{required: true, message: '提交时自动审批不能为空', trigger: 'blur'}],
        sort: [{required: true, message: '排序值不能为空', trigger: 'blur'}],
        type: [{required: true, message: '表单类型不能为空', trigger: 'blur'}],
        status: [{required: true, message: '状态不能为空', trigger: 'blur'}],
        version: [{required: true, message: '版本不能为空', trigger: 'blur'}],
    })

    // 打开弹窗
    const openDialog = (type: string, id: string) => {
        visible.value = true
        operType.value = type;
        form.id = ''

        if (type === 'add') {
            title.value = t('common.addBtn');
        } else if (type === 'edit') {
            title.value = t('common.editBtn');
        } else if (type === 'view') {
            title.value = t('common.viewBtn');
        }

        // 重置表单数据
        nextTick(() => {
            dataFormRef.value?.resetFields();
        });

        // 获取TabsOption信息
        if (id) {
            form.id = id
            getTabsOptionData(id)
        }
    };

    function handleAddGroupName() {
        useMessageBox().prompt("请输入新的分组名称")
            .then(({ value }) => {
                form.groupName = value
                onUpdate(dicData, form);
            })
    }

    // 提交
    const onSubmit = async () => {
        const valid = await dataFormRef.value.validate().catch(() => {});
        if (!valid) return false;

        if (form.type === DIC_PROP.FORM_TYPE[1].value) {
            if (!form.path) {
                notifyLeft('当前表单类型为系统表单，【PC端路径】不能为空', 'warning')
                return false
            }
        }
        let isDesign = form.type !== DIC_PROP.FORM_TYPE[1].value;
        if (isDesign && !form.formInfo) {
            notifyLeft('当前表单类型为设计表单，请先完善第二项设计的表单内容', 'warning')
            return false
        }
        validateFormTypeSave(form)
        try {
            loading.value = true;
            form.id ? await putObj(form) : await addObj(form);
            useMessage().success(t(form.id ? 'common.editSuccessText' : 'common.addSuccessText'));
            visible.value = false;
            emit('refresh');
        } catch (err: any) {
            useMessage().error(err.msg);
        } finally {
            loading.value = false;
        }
    };

    // 初始化表单数据
    const getTabsOptionData = (id: string) => {
        // 获取数据
        loading.value = true
        getObj(id).then((res: any) => {
            Object.assign(form, res.data)
        }).finally(() => {
            loading.value = false
        })
    };

    // 暴露变量
    defineExpose({
        openDialog
    });
</script>
